Codeforces Round #379 (Div. 2) C. Anton and Making Potions 枚举+二分

C. Anton and Making Potions

题目连接:

http://codeforces.com/contest/734/problem/C

Description

Anton is playing a very interesting computer game, but now he is stuck at one of the levels. To pass to the next level he has to prepare n potions.

Anton has a special kettle, that can prepare one potions in x seconds. Also, he knows spells of two types that can faster the process of preparing potions.

Spells of this type speed up the preparation time of one potion. There are m spells of this type, the i-th of them costs bi manapoints and changes the preparation time of each potion to ai instead of x.
Spells of this type immediately prepare some number of potions. There are k such spells, the i-th of them costs di manapoints and instantly create ci potions.
Anton can use no more than one spell of the first type and no more than one spell of the second type, and the total number of manapoints spent should not exceed s. Consider that all spells are used instantly and right before Anton starts to prepare potions.

Anton wants to get to the next level as fast as possible, so he is interested in the minimum number of time he needs to spent in order to prepare at least n potions.

Input

The first line of the input contains three integers n, m, k (1 ≤ n ≤ 2·109, 1 ≤ m, k ≤ 2·105) — the number of potions, Anton has to make, the number of spells of the first type and the number of spells of the second type.

The second line of the input contains two integers x and s (2 ≤ x ≤ 2·109, 1 ≤ s ≤ 2·109) — the initial number of seconds required to prepare one potion and the number of manapoints Anton can use.

The third line contains m integers ai (1 ≤ ai < x) — the number of seconds it will take to prepare one potion if the i-th spell of the first type is used.

The fourth line contains m integers bi (1 ≤ bi ≤ 2·109) — the number of manapoints to use the i-th spell of the first type.

There are k integers ci (1 ≤ ci ≤ n) in the fifth line — the number of potions that will be immediately created if the i-th spell of the second type is used. It’s guaranteed that ci are not decreasing, i.e. ci ≤ cj if i < j.

The sixth line contains k integers di (1 ≤ di ≤ 2·109) — the number of manapoints required to use the i-th spell of the second type. It’s guaranteed that di are not decreasing, i.e. di ≤ dj if i < j.

Output

Print one integer — the minimum time one has to spent in order to prepare n potions.

Sample Input

20 3 2
10 99
2 4 3
20 10 40
4 15
10 80

Sample Output

20

Hint

题意

你需要制作n瓶药水,每一瓶药水需要x秒。

你现在有m种A魔法,花费b[i],使得每一瓶药水的花费代价降为a[i],只能用一次。

有K种B魔法,花费d[i],使得瞬间制作好c[i]瓶药水,只能用一次。

你最多花费s的魔法值

问你最快完成要多少秒。

题解:

枚举使用哪一个A魔法,然后再二分判断使用哪一个B魔法,显然B魔法在当前魔法值剩余的情况下,制作越多越好。

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 2e5+6;
int n,m,k,x,s;
long long a[maxn],b[maxn],c[maxn],d[maxn];
int main()
{
    scanf("%d%d%d",&n,&m,&k);
    scanf("%d%d",&x,&s);
    for(int i=1;i<=m;i++)scanf("%lld",&a[i]);
    for(int i=1;i<=m;i++)scanf("%lld",&b[i]);
    for(int i=1;i<=k;i++)scanf("%lld",&c[i]);
    for(int i=1;i<=k;i++)scanf("%lld",&d[i]);
    a[0]=x;
    long long ans =1ll * n * x;
    for(int i=0;i<=m;i++){
        if(s<b[i])continue;
        int l=0,r=k,Ans=0;
        while(l<=r){
            int mid=(l+r)/2;
            if(d[mid]+b[i]<=s)Ans=mid,l=mid+1;
            else r=mid-1;
        }
        ans=min(ans,1ll*a[i]*(n-c[Ans]));
    }
    cout<<ans<<endl;
}
    原文作者:qscqesze
    原文地址: https://www.cnblogs.com/qscqesze/p/6069216.html
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞